Index: GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 1914)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 1916)
@@ -504,5 +504,4 @@
 		// decrease the weighted average cost of the subdivisoin
 		mTotalCost -= sc->GetRenderCostDecrease();
-		cout << "))))))))))))) " << sc->GetRenderCostDecrease() << endl;
 		mPvsEntries += sc->GetPvsEntriesIncr();
 
@@ -637,5 +636,4 @@
 	const float avgRayContri = AvgRayContribution((int)pvs, tData.mNumRays);
 
-	cout << "bvh avg ray contri: " << avgRayContri << endl;
 	// high avg ray contri, the result is influenced by undersampling
 	splitCandidate.SetAvgRayContribution(avgRayContri);
@@ -650,22 +648,15 @@
 	const float backVol = EvalViewCellsVolume(splitCandidate.mBackObjects) / GetViewSpaceVolume();
 
-	cout <<"here8 "<< parentVol << " " << " old vol: " << oldVolume << " frontvol: " << frontVol << endl;
 	splitCandidate.mCorrectedFrontVolume = 
 		mHierarchyManager->EvalCorrectedPvs(frontVol, parentVol, avgRayContri);
-
-	cout << "bvh front vol: " << frontVol << " corrected: " << splitCandidate.mCorrectedFrontVolume << endl;
-	cout <<"here104 "<< endl;
-
+	
 	splitCandidate.mCorrectedBackVolume = 
 		mHierarchyManager->EvalCorrectedPvs(backVol, parentVol, avgRayContri);
 	
-	cout << "back vol: " << backVol << " corrected: " << splitCandidate.mCorrectedBackVolume << endl;
-
 	const float relfrontCost = splitCandidate.mCorrectedFrontVolume * 
 		EvalAbsCost(splitCandidate.mFrontObjects);
 	const float relBackCost =  splitCandidate.mCorrectedBackVolume * 
 		EvalAbsCost(splitCandidate.mBackObjects);
-	const float relParentCost = parentVol * 
-		EvalAbsCost(leaf->mObjects);
+	const float relParentCost = parentVol * EvalAbsCost(leaf->mObjects);
 
 	// compute global decrease in render cost
@@ -678,5 +669,11 @@
 	const int pvsEntriesIncr = EvalPvsEntriesIncr(splitCandidate, avgRayContri);
 	splitCandidate.SetPvsEntriesIncr(pvsEntriesIncr);
-	
+
+	cout << "bvh volume cost"
+		 << " avg ray contri: " << avgRayContri << " ratio: " << oldRatio 
+		 << " parent: " << parentVol << " " << " old vol: " << oldVolume 
+		 << " frontvol: " << frontVol << " corr. " << splitCandidate.mCorrectedFrontVolume 
+		 << " backvol: " << backVol << " corr. " << splitCandidate.mCorrectedBackVolume << endl;
+
 #ifdef GTP_DEBUG
 	Debug << "old render cost: " << oldRenderCost << endl;
@@ -705,11 +702,14 @@
 	const int backViewCells = CountViewCells(splitCandidate.mBackObjects);
 	
-	cout <<"here105 " << splitCandidate.mParentData.mCorrectedPvs << endl;
-	cout <<"here106 " << oldPvsRatio << endl;
-
 	splitCandidate.mCorrectedFrontPvs = 
 		mHierarchyManager->EvalCorrectedPvs((float)frontViewCells, parentPvs, avgRayContri);
 	splitCandidate.mCorrectedBackPvs =
 		mHierarchyManager->EvalCorrectedPvs((float)backViewCells, parentPvs, avgRayContri);
+
+	cout << "bvh pvs"
+		 << " avg ray contri: " << avgRayContri << " ratio: " << oldPvsRatio 
+		 << " parent: " << parentPvs << " " << " old vol: " << oldPvsSize
+		 << " frontpvs: " << frontViewCells << " corr. " << splitCandidate.mCorrectedFrontPvs 
+		 << " backpvs: " << frontViewCells << " corr. " << splitCandidate.mCorrectedBackPvs << endl;
 
 	return (int)(splitCandidate.mCorrectedFrontPvs + splitCandidate.mCorrectedBackPvs - parentPvs);
@@ -2224,6 +2224,5 @@
 	oData.mCorrectedPvs = oData.mPvs = (float)mPvsEntries;
 	oData.mCorrectedVolume = oData.mVolume = prop;
-	cout << "here52 " << oData.mCorrectedPvs << " " << oData.mVolume << " " << oData.mCorrectedVolume  << " prop: " << prop << endl;
-
+	
 	BvhSubdivisionCandidate *oSubdivisionCandidate = 
 		new BvhSubdivisionCandidate(oData);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1910)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1916)
@@ -147,7 +147,9 @@
 
 	// mix of sampling strategies
-	mStrategies.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
-	mStrategies.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-	mStrategies.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
+	mStrategies.push_back(SamplingStrategy::OBJECT_DIRECTION_BASED_DISTRIBUTION);
+	
+	//mStrategies.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
+	//mStrategies.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
+	//mStrategies.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
 	
 	//mStrategies.push_back(SamplingStrategy::SPATIAL_BOX_BASED_DISTRIBUTION);
@@ -6042,7 +6044,9 @@
 
 	// mix of sampling strategies
-	evalStrats.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
-	evalStrats.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-	evalStrats.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
+	mStrategies.push_back(SamplingStrategy::OBJECT_DIRECTION_BASED_DISTRIBUTION);
+
+	//evalStrats.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
+	//evalStrats.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
+	//evalStrats.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
 
 	//evalStrats.push_back(SamplingStrategy::SPATIAL_BOX_BASED_DISTRIBUTION);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 1915)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 1916)
@@ -840,6 +840,5 @@
 
 	splitCandidate.SetAvgRayContribution(avgRayContri);
-	cout << "vsp avg ray contri: " << avgRayContri << endl;
-
+	
 	// compute global decrease in render cost
 	float oldRenderCost;
@@ -900,11 +899,8 @@
 	const float correctedOldPvs = splitCandidate.mParentData.mCorrectedPvs * oldPvsRatio;
 
-	cout <<"here102 old pvs ratio: " << oldPvsRatio << " " << splitCandidate.mParentData.mPvs << " " << oldPvsSize << endl;
-
 	splitCandidate.mCorrectedFrontPvs = 
 		mHierarchyManager->EvalCorrectedPvs(fPvsSize, 
 											correctedOldPvs, 
 											splitCandidate.GetAvgRayContribution());
-	cout <<"here103 "<< endl;
 	splitCandidate.mCorrectedBackPvs = 
 		mHierarchyManager->EvalCorrectedPvs(bPvsSize, 
@@ -912,6 +908,11 @@
 											splitCandidate.GetAvgRayContribution());
 	
-	cout << "vsp front entries " << fPvsSize << " corrected: " << splitCandidate.mCorrectedFrontPvs << endl;
-	cout << "vsp back entries " << bPvsSize << " corrected: " << splitCandidate.mCorrectedBackPvs << endl;
+	
+	cout << "vsp pvs"
+		 << " avg ray contri: " << splitCandidate.GetAvgRayContribution() << " ratio: " << oldPvsRatio 
+		 << " parent: " << correctedOldPvs << " " << " old vol: " << oldPvsSize
+		 << " frontpvs: " << fPvsSize << " corr. " << splitCandidate.mCorrectedFrontPvs 
+		 << " backpvs: " << bPvsSize << " corr. " << splitCandidate.mCorrectedBackPvs << endl;
+
 
 	return (int)(splitCandidate.mCorrectedFrontPvs + splitCandidate.mCorrectedBackPvs - correctedOldPvs);
@@ -1607,11 +1608,6 @@
 	const float penaltyOld = tData.mCorrectedRenderCost * oldRenderCostRatio;
 
-	cout <<"here107 old render cost ratio " << oldRenderCostRatio << " old cost: " << penaltyOld << endl;
 	sc.mCorrectedFrontRenderCost = mHierarchyManager->EvalCorrectedPvs(pvsFront, penaltyOld, avgRayContri);
-	cout <<"here108 " << tData.mCorrectedRenderCost << " " << oldRenderCostRatio << endl;
 	sc.mCorrectedBackRenderCost = mHierarchyManager->EvalCorrectedPvs(pvsBack, penaltyOld, avgRayContri);
-
-	cout << "vsp front pvs " << pvsFront << " corrected: " << sc.mCorrectedFrontRenderCost << endl;
-	cout << "vsp back render cost " << pvsBack << " corrected: " << sc.mCorrectedBackRenderCost << endl;
 
 	const float oldRenderCost = pOverall * penaltyOld;
@@ -1624,4 +1620,10 @@
 	// the render cost decrase for this split
 	const float renderCostDecrease = (oldRenderCost - newRenderCost) / viewSpaceVol;
+
+	cout << "vsp render cost"
+		 << " avg ray contri: " << avgRayContri << " ratio: " << oldRenderCostRatio
+		 << " parent: " << penaltyOld << " " << " old vol: " << totalPvs 
+		 << " front cost: " << sc.mCorrectedFrontRenderCost << " corr. " << sc.mCorrectedFrontRenderCost
+		 << " back cost: " << sc.mCorrectedBackRenderCost << " corr. " << sc.mCorrectedBackRenderCost << endl;
 
 #ifdef GTP_DEBUG
Index: GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 1915)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 1916)
@@ -744,5 +744,4 @@
 	if (avgRayContri < mMinAvgRayContri)
 	{
-		cout << "here4 child" << endl;
 		return childPvs;
 	}
@@ -750,5 +749,4 @@
 	if (avgRayContri > mMaxAvgRayContri)
 	{
-		cout << "here9 parent" << endl;
 		return totalPvs;
 	}
@@ -764,5 +762,5 @@
 #endif
 
-	cout << "alpha " << alpha << " beta: " << beta << " child: " << childPvs << " parent: " << totalPvs << endl;
+	//cout << "alpha " << alpha << " beta: " << beta << " child: " << childPvs << " parent: " << totalPvs << endl;
 	
 	if ((newPvs < childPvs - Limits::Small) || (newPvs > totalPvs + Limits::Small))